
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>OpenGL ES From the Ground Up, Part 1: Basic Concepts / iVAN</title>

    <meta name="description" content="OpenGL ES From the Ground Up, Part 1: Basic Concepts FRIDAY, APRIL 17, 2009 OpenGL ES From the Ground Up, Part 1: Basic Concepts I've done a number of postings on programming OpenGL ES for the iPhone, but most of the posts I've done have been targeted at people who already know at least a little bit ab">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">OpenGL ES From the Ground Up, Part 1: Basic Concepts</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<h2>FRIDAY, APRIL 17, 2009</h2>
<h3><a href="http://iphonedevelopment.blogspot.com/2009/04/opengl-es-from-ground-up-part-1-basic.html" rel="external nofollow noreferrer">OpenGL ES From the Ground Up, Part 1: Basic Concepts</a></h3>
<p>I've done a number of postings on programming OpenGL ES for the iPhone, but most of the posts I've done have been targeted at people who already know at least a little bit about 3D programming.</p>
<p>If you haven't already done so, grab a copy of my Empty OpenGL Xcode project template. We'll use <a href="http://www.innerloop.biz/code/Empty%20OpenGL%20ES%20Application.zip" rel="external nofollow noreferrer">this template</a> as<br />
 a starting point rather than Apple's provided one. You can install it by copying the unzipped folder to this location:
<pre>/Developer/Platforms/iPhoneOS.platform/Developer/Library/Xcode/Project Templates/Application/</pre>
<p>There are a number of good tutorials and books on OpenGL. Unfortunately, there aren't very many on OpenGL ES, and none (at least as I write this) that are specifically designed for learning 3D programming on the iPhone. Because most available material for learning<br />
 OpenGL starts out teaching using what's called <em>direct mode</em>, which is part of the functionality of OpenGL that's not in OpenGL ES, it can be really hard for an iPhone dev with no 3D background to get up and running using existing books and tutorials.<br />
 I've had a number of people request it, so I've decided to start a series of blog posts designed for the absolute 3D beginner. This is the first in that series. If you've read and understood my previous OpenGL postings, you will probably find this series to<br />
 be a little too basic.</p>
<h3>OpenGL Datatypes</h3>
<p>The first thing we'll talk about are OpenGL's datatypes. Because OpenGL is a cross-platform API, and the size of datatypes can vary depending on the programming language being used as well as the underlying processor (64-bit vs. 32-bit vs 16-bit), OpenGL declares<br />
 its own custom datatypes. When passing values into OpenGL, you should always use these OpenGL datatypes to make sure that you are passing values of the right size or precision. Failure to do so could cause unexpected results or slowdowns caused by data conversion<br />
 at runtime. Every implementation of OpenGL, regardless of platform or language, declares the standard OpenGL datatypes in such a way that they will be the same size on every platform, making porting OpenGL code from one platform to another easier.</p>
<p>Here are the OpenGL ES datatypes:
<ul>
<li><strong>GLenum</strong>: An unsigned integer used for GL-specific enumerations. Most commonly used to tell OpenGL the type of data stored in an array passed by pointer (e.g. GL_FLOAT)<br />
 to indicate that the array is made up of GLfloats.</li>
<li><strong>GLboolean</strong>: Used to hold a single boolean values. OpenGL ES also declares its own true and false values (GL_TRUE and GL_FALSE)<br />
 to avoid platform and language differences. When passing booleans into OpenGL, use these rather than YES or NO (though it won't hurt if you accidentally use YES orTRUE since<br />
 they are actually defined the same. But, it's good form to use the GL-defined values.</li>
<li><strong>GLbitfield</strong>: These are four-byte integers used to pack multiple boolean values (up to 32) into a single variable using bitwise operators. We'll discuss this more the first time we use a bitfield<br />
 variable, but you can <a href="http://en.wikipedia.org/wiki/Bit_field" rel="external nofollow noreferrer">read up on the basic idea over at wikipedia</a></li>
<li><strong>GLbyte</strong>: A signed, one-byte integer capable of holding a value from -128 to 127</li>
<li><strong>GLshort</strong>: A signed two-byte integer capable of holding a value between −32,768 to 32,767</li>
<li><strong>GLint</strong>: A signed four-byte integer capable of holding a value between −2,147,483,648 and 2,147,483,647</li>
<li><strong>GLsizei</strong>: A signed, four-byte integer used to represent the size (in bytes) of data, similar to size_t in C.</li>
<li><strong>GLubyte</strong>: An unsigned, one-byte integer capable of holding a value between 0 and 255.</li>
<li><strong>GLushort</strong>: An unsigned, two-byte integer capable of holding a value between 0 and 65,535</li>
<li><strong>GLuint</strong>: An unsigned, four-byte integer capable of holding a value between 0 and 4,294,967,295</li>
<li><strong>GLfloat</strong>: A four-byte precision <a href="http://en.wikipedia.org/wiki/IEEE_754-1985" rel="external nofollow noreferrer">IEEE 754-1985</a> floating<br />
 point variable.</li>
<li><strong>GLclampf</strong>: This is also a four-byte precision floating point variable, but when OpenGL uses GLclampf, it is indicating that the value of this particular<br />
 variable should always be between 0.0 and 1.0.</li>
<li><strong>GLvoid</strong>: A void value used to indicate that a function has no return value, or takes no arguments.</li>
<li><strong>GLfixed</strong>: <a href="http://en.wikipedia.org/wiki/Fixed-point_arithmetic" rel="external nofollow noreferrer">Fixed point numbers</a> are a way of<br />
 storing real numbers using integers. This was a common optimization in 3D systems used because most computer processors are much faster at doing math with integers than with floating-point variables. Because the iPhone has vector processors that OpenGL uses<br />
 to do fast floating-point math, we will not be discussing fixed-point arithmetic or the GLfixed datatype.</li>
<li><strong>GLclampx</strong>: Another fixed-point variable, used to represent real numbers between 0.0 and 1.0 using fixed-point arithmetic. Like GLfixed, we won't be using<br />
 or discussing this datatype.</li>
</ul>
<p>OpenGL ES (at least the version used on the iPhone) does not support any 8-byte (64-bit) datatypes such as long or double. OpenGL does have these larger datatypes, but given<br />
 the screen size of most embedded devices, and the types of applications you are likely to be writing for them, the decision was made to exclude them from OpenGL ES under the assumption that there would be little need for them, and that their use could have<br />
 a detrimental effect on performance.</p>
<h3>The Point or Vertex</h3>
<p>The atomic unit in 3D graphics is called the <strong>point</strong> or <strong>vertex</strong>. These represent a single spot in three dimensional space and are used to build more complex objects. Polygons are built out of these points, and objects are built<br />
 out of multiple polygons. Although regular OpenGL supports many types of polygons, OpenGL ES only supports the use of three-sided polygon, (aka triangles).</p>
<p>If you remember back to high-school geometry, you probably remember something called <a href="http://en.wikipedia.org/wiki/Cartesian_coordinate" rel="external nofollow noreferrer">Cartesian Coordinates</a>.<br />
 The basic idea is that you select an arbitrary point in space and call it the <strong>origin</strong>. You can then designate any point in space by referencing the origin and using three numbers, one for each of the three dimensions, which are represented<br />
 by three imaginary lines running through the origin. The imaginary line running from left to right is called the x-axis. Traveling along the x-axis, as you go to the right along the x axis, the value gets higher and as you go to the left, they get lower. Left<br />
 of the origin are negative x values, and to the right are positive x values. The other two axes work exactly the same way. Going up along the y axis, the value of y increases, and going down, it decreases. Values above the origin have a positive y value, and<br />
 those below the origin have a negative y value. With z, as objects move away from the viewer, the value gets lower, and as they move toward the viewer (or continue behind the viewer), values get higher. Points that are in front of the origin have a positive<br />
 z value, and those that are behind the origin have a negative z value. The following illustration might make help those words make a little more sense:</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbGg2LmdncGh0LmNvbS9fUUx3bXMwbVZhNHcvU2VpYkJMUjl4VkkvQUFBQUFBQUFBUk0vcF9mS1ZnR3NLbTAvY2FydGVzaWFuLnBuZz9pbWdtYXg9ODAw.jpg"></p>
<blockquote><p><strong>Note:</strong> Core Graphics, which is another framework for doing graphics on the iPhone uses a slightly different coordinate system in that the y axis decreases as it goes up from the origin, and increases as it goes down.</p></blockquote>
<p>The value that increases or decreases along these axes are in an arbitrary scale - they don't represent any real measurement, like feet, inches, or meters. You can select any scale that makes sense for your own programs. If you want to design a game where each<br />
 unit is a foot, you can do that. if you want to make each unit a micron, you can do that as well. OpenGL doesn't care what they represent to the end user, it just thinks of them as units, and make sure they are all equal distances.</p>
<p>Since any object's location in three-dimensional space can be represented by three values, an object's position is generally represented in OpenGL by the use of three GLfloat variables, usually using an array of three<br />
 floats, where the first item in the array (index 0) is the x position, the second (index 1) is the y position, and the third (index 2) is the z position. Here's a very simple example of creating a vertex for use in OpenGL ES:</p>
<pre>    GLfloat vertex[3];
    vertex[0] = 10.0;       // x
    vertex[1] = 23.75;      // y
    vertex[2] = -12.532;    // z</pre>
<p>In OpenGL ES, you generally submit all the vertices that make up some or all of the objects in your scene as a <strong>vertex array</strong>. A vertex array is simply an array of values (usually GLfloats) that contains<br />
 the vertex data for some or all of the objects in the world. We'll see how that process works in the next post in this series, but the thing to remember about vertex arrays is that their size is based on the number of vertices being submitted multiplied by<br />
 either three (for drawing in three-dimensional space) or two (for drawing in two-dimensional space). So, a vertex array that holds six triangles in three-dimensional space would consist of an array of 54 GLfloats,<br />
 because each triangle has three vertices, and each vertex has three coordinates and 6 x 3 x 3 = 54.</p>
<p>Dealing with all these GLfloats can be a pain, however, because you're constantly having to multiply things in your head and try to think of these arrays in terms of the vertices and polygons that they represent. Fortunately,<br />
 there's an easier way. We can define a data structure to hold a single vertex, like this: </p>
<pre>typedef struct {
    GLfloat x;
    GLfloat y;
    GLfloat z;
} Vertex3D;
</pre>
<p>By doing this, our code becomes much more readable:</p>
<pre>Vertex3D vertex;
vertex.x = 10.0;
vertex.y = 23.75;
vertex.z = -12.532;</pre>
<p>Now, because our Vertex3D struct is comprised of three GLfloats, passing a pointer to a Vertex3D is exactly the same as passing<br />
 a pointer to an array of threeGLfloats. There's no difference to the computer; both have the same size and the same number of bytes in the same order as OpenGL expects them. Grouping the data into these data structures<br />
 just makes it easier for us as the programmer to visualize and deal with the data. If you download my Xcode template from the beginning of this article, this data structure and the supporting functions I'm going to be discussing next have already been defined<br />
 in the file named<em>OpenGLCommon.h</em>. There is also an inline function for creating single vertices:</p>
<pre>static inline Vertex3D Vertex3DMake(CGFloat inX, CGFloat inY, CGFloat inZ)
{
    Vertex3D ret;
    ret.x = inX;
    ret.y = inY;
    ret.z = inZ;
    return ret;
}</pre>
<p>If you remember back to geometry (or maybe you don't, which is okay), the distance between two points on a plane is calculated using this formula: </p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbGg1LmdncGh0LmNvbS9fUUx3bXMwbVZhNHcvU2Vpenc4WWhLSUkvQUFBQUFBQUFBUlUvYXRnZjlHajNLZzgvZGlzdGFuY2UlMjBmb3JtdWxhLnBuZz9pbWdtYXg9ODAw.jpg"></p>
<p>We can implement this formula to calculate the straight-line distance between any two points in three-dimensional space with this simple inline function:</p>
<pre>static inline GLfloat Vertex3DCalculateDistanceBetweenVertices (Vertex3D first, Vertex3D second)
{
    GLfloat deltaX = second.x - first.x;
    GLfloat deltaY = second.y - first.y;
    GLfloat deltaZ = second.z - first.z;
    return sqrtf(deltaX*deltaX + deltaY*deltaY + deltaZ*deltaZ );
};</pre>
<h3>Triangles</h3>
<p>Since OpenGL ES only supports triangles, we can also create a data structure to group three vertices into a single triangle object.</p>
<pre>typedef struct {
    Vertex3D v1;
    Vertex3D v2;
    Vertex3D v3;
} Triangle3D;</pre>
<p>Again, a single Triangle3D is exactly the same as an array of nine GLfloats, it's just easier for us to deal with it in our code because we can build objects out of vertices<br />
 and triangles rather than out of arrays of GLfloats.</p>
<p>There are a few more things you need to know about triangles, however. In OpenGL, there is a concept known as <strong>winding</strong>, which just means that the order in which the vertices are drawn matters. Unlike objects in the real world, polygons in OpenGL<br />
 do not generally have two sides to them. They have one side, which is considered the <strong>front face</strong>, and a triangle can only be seen if its front face if facing the viewer. While it is possible to configure OpenGL to treat polygons as two-sided,<br />
 by default, triangles have only one visible side. By knowing which is the front or visible side of the polygon, OpenGL is able to do half the amount of calculations per polygon that it would have to do if both sides were visible. </p>
<p>Although there are times when a polygon will stand on its own, and you might very well want the back drawn, usually a triangle is part of a larger object, and one side of the polygon will be facing the inside of the object and will never be seen. The side that<br />
 isn't drawn is called a <strong>backface</strong>, and OpenGL determines which is the front face to be drawn and which is the backface by looking at the drawing order of the vertices. The front face is the one that would be drawn by following the vertices<br />
 in counter-clockwise order (by default, it can be changed). Since OpenGL can determine easily which triangles are visible to the user, it can use a process called <strong>Backface Culling</strong> to avoid doing work for polygons that aren't facing the front<br />
 of the viewport and, therefore, can't be seen. We'll discuss the viewport in the next posting, but you can think of it as the virtual camera, or virtual window looking into the OpenGL world.</p>
<p><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvbGgzLmdncGh0LmNvbS9fUUx3bXMwbVZhNHcvU2VpMjViaWxBb0kvQUFBQUFBQUFBUlkvM3IxSW9GeU9PR3cvd2luZGluZy5wbmc/aW1nbWF4PTgwMA==.jpg"></p>
<p>In the illustration above, the cyan triangle on the left is a backface and won't be drawn because the order that the vertices would be drawn in relation to the viewer is clockwise. On the other hand, the triangle on the right is a frontface that will be drawn<br />
 because the order of the vertices is counter-clockwise in relation to the viewer.</p>
<p>In the next posting in this series, we'll look at setting up the virtual world in OpenGL and do some simple drawing using Vertex3D and Triangle3D. In the post after that,<br />
 we'll look at <strong>transformations</strong> which are a way of using linear algebra to move objects around in the virtual world.</p>
<p>POSTED BY JEFF LAMARCHE AT <a href="http://iphonedevelopment.blogspot.com/2009/04/opengl-es-from-ground-up-part-1-basic.html" rel="external nofollow noreferrer">10:17<br />
 AM</a></p>
<p>LABELS: <a href="http://iphonedevelopment.blogspot.com/search/label/Cocoa%20Touch" rel="external nofollow noreferrer">COCOA TOUCH</a>, <a href="http://iphonedevelopment.blogspot.com/search/label/Game%20Programming" rel="external nofollow noreferrer">GAME<br />
 PROGRAMMING</a>, <a href="http://iphonedevelopment.blogspot.com/search/label/iPhone%20SDK" rel="external nofollow noreferrer">IPHONE SDK</a>, <a href="http://iphonedevelopment.blogspot.com/search/label/OpenGL%20ES" rel="external nofollow noreferrer">OPENGL<br />
 ES</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-19 04:44:39</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/opengl/" title="opengl">opengl</a>, <a href="https://www.iamivan.net/tag/single/" title="single">single</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>OpenGL ES From the Ground Up, Part 1: Basic Concepts的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pmKmxab.html" rel="bookmark">OpenGL ES From the Ground Up&comma; Part 5&colon; Living in a Material World</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				WEDNESDAY, MAY 13, 2009 OpenGL ES From the Ground Up, Part 5: Living in a Material World Okay, in the last installment, we talked about lights, how to set them up and what attributes they have. We also talked about the three components of light,diffu			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Z2DAz.html" rel="bookmark">OpenGL ES From the Ground Up&comma; Part 4&colon; Let There Be Light&excl;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				FRIDAY, MAY 1, 2009 OpenGL ES From the Ground Up, Part 4: Let There Be Light! Continuing on with OpenGL ES for the iPhone, let's talk about light. So far, we haven't done anything with light. Fortunately, OpenGL still lets us see what's going on if w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/b3rPOAz.html" rel="bookmark">OpenGL ES From the Ground Up&comma; Part 6&colon; Textures and Texture Mapping</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MONDAY, MAY 25, 2009 OpenGL ES From the Ground Up, Part 6: Textures and Texture Mapping An alternative to creating materials in OpenGL ES to define the color of a polygon is to map a texture onto that polygon. This is a handy options that can give yo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MNvG57M.html" rel="bookmark">OpenGL ES From the Ground Up&comma; Part 2&colon; A Look at Simple Drawing</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MONDAY, APRIL 20, 2009 OpenGL ES From the Ground Up, Part 2: A Look at Simple Drawing Okay, there's still a lot of theory to talk about, but before we spend too much time getting bogged down in complex math or difficult concepts, let's get our feet w			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MAQZWKM.html" rel="bookmark">OpenGL ES From the Ground Up&comma; Part 1 Addendum&colon; Alphabet Soup</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				MONDAY, MAY 4, 2009 OpenGL ES From the Ground Up, Part 1 Addendum: Alphabet Soup One problem with blog postings is that they are self-edited. For my postings here, I have no external technical review and no copy editing done. Mostly, it's not too muc			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M9YaW4M.html" rel="bookmark">从零开始学习OpenGL ES之六 &ndash; 纹理及纹理映射</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转自:http://bbs.ityran.com/article-9-1.html [转载]从零开始学习OpenGL ES之六 – 纹理及纹理映射 2011-9-14 23:49| 发布者: Iven| 查看: 9206| 评论: 15 摘要: 图形图像, 编程,编程, OpenGL ES, 教程,OpenGL ES 3D 在OpenGL ES中另一种为多边形定义颜色创建材质的方法是将纹理映射到多边形.这是一种很实用的方法,它可以产生很漂亮的外观并节省大量的处理器时间.比如说,你想在游戏中造一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/aM6eoYb.html" rel="bookmark">第二章 你好三角形&colon;一个OpenGL ES 2&period;0例子</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				介绍基本概念的OpenGL ES 2.0,我们首先从一个简单的例子.在这一章里,我们将展示什么是需要创建一个OpenGL ES 2.0一个三角形的项目..我们要编写的程序是最基本的例子,一个OpenGL ES 2.0应用程序,绘制几何.有数量的概念,我们将介绍在本章: 1.创建一个屏幕渲染表面与EGL. 2.加载片段着色器和定点. 3.创建程序的对象,附着顶点和片段着色器,连接程序对象. 4.设置窗口. 5.清除颜色缓冲. 6.渲染一个简单的例子. 7.使内容的颜色缓冲可见在EGL窗口表面. 事			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MqLjrRb.html" rel="bookmark">Android开发之OpenGL ES 颜色</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.基础知识: 1.平滑着色(Smooth coloring): 将多个顶点的不同颜色混合在一起,创建出漂亮的色彩混合. 2.单调着色: 给图形涂上一种固定单一的颜色. 3.三角形定义的颜色数组(平滑着色): [java] int one = 0x10000; //三角形的顶点颜色值(r,g,b,a) private IntBuffer colorBuffer = IntBuffer.wrap(new int[]{ one,0,0,one, 0,one,0,one, 0,0,one,one, }			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/p5Ay8Rp.html" rel="bookmark">Android开发之OpenGL ES 画多边形</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.基础知识: OpenGL ES目前只支持三角形,但任何多边形都可拆分成多个三角形,所以无所谓这个限制的存在. 1.OpenGL中的坐标点: 每一个坐标点由(X, Y, Z)组成. 定义一个三角形的顶点数组: [java] int one = 0x10000; //三角形三个顶点 private IntBuffer triggerBuffer = IntBuffer.wrap(new int[]{ 0,one,0, //上顶点 -one,-one,0, //左下点 one,-one,0,});			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/0bo7QEb.html" rel="bookmark" class="title">Akka笔记之日志及测试</a>
					<div>
						英文原文链接,译文链接,原文作者:Arun Manivannan ,译者:有孚 在前两篇笔记中(第一篇,第二篇),我们简单地介绍了一下Actor以及它的消息传递是如何工作的.在本篇中,我们将看下如何解 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/yMA7Lnz.html" rel="bookmark" class="title">核心路由器十项性能指标</a>
					<div>
						高速路由器的系统交换能力与处理能力是其有别于一般路由器能力的重要体现.目前,高速路由器的背板交换能力应达到40Gbps以上,同时系统即使暂时不提供OC-192/STM-64接口,也必须在将来无须对现有 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/lpP5Yqz.html" rel="bookmark" class="title">Dreamweaver网页中实用的制作技巧</a>
					<div>
						dreamweaver|技巧|网页 1.灵活运用样式 熟悉网页设计的网友就知道,调用Style的方法很多,我们可以单击鼠标右键选择Custon Style来调用Style标准,也可以在状态栏中的元素列 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlRO1qz.html" rel="bookmark" class="title">linux kill进程和子进程小trick</a>
					<div>
						我们的hive web是调用polestar restful service(https://github.com/lalaguozhe/polestar-1)来执行具体的hive或者shark语句的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2ynxVz.html" rel="bookmark" class="title">WCF分布式开发步步为赢&lpar;9&rpar;&colon;WCF服务实例激活类型编程与开发</a>
					<div>
						.Net Remoting的激活方式也有三种:SingleTon模式.SingleCall模式.客户端激活方式,WCF服务实例激活类型包括三种方式:单调服务(Call Service),会话服务(Se ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvKyW9p.html" rel="bookmark" class="title">IE9的兼容性如何？我还能使用网银和支付宝吗？</a>
					<div>
						根据我们的测试结果来看,大部分网站在 IE9 下都可以正常浏览,多数网上银行,以及支付宝也能够正常操作.但为了满足互联网高速发展的需求,IE9 的基本组件进行了大量的改进,包括新的 JS 引擎.DOM ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zDAlyLb.html" rel="bookmark" class="title">简约而不简单的PPT设计原则</a>
					<div>
						  极简主义 可谓去芜存菁,聚焦重点.也就是说,极简主义披荆斩棘,直达目标.既然是极简主义,那么最终呈现的外观自然是简洁二字,精心思考.屡次尝试以及大量时间均融合包含在这简约中.下面,我们就来分解极简 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg33N3M.html" rel="bookmark" class="title">时尚大片的后期处理秘笈</a>
					<div>
						  我们为大家揭秘时尚大片中最常用的一些处理技巧,告诉大家如何在不失真实的前提下改善皮肤质感.移除画面瑕疵. 人像处理是一门艺术,处理时既要让人物看上去尽可能完美,又要保证不因调整操作而失真.如何平衡 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnY6WZM.html" rel="bookmark" class="title">Win8一键影音图标隐藏后恢复</a>
					<div>
						故障现象: 将Y400/Y500预装的OneKey Theater 一键影音图标在任务栏隐藏后,不知道该如何恢复? 解决方案: 方法一 Metro开始菜单中点击一下'OneKey Theater'图标 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pXjexAb.html" rel="bookmark" class="title">组装电脑前的准备工作</a>
					<div>
						组装电脑已经不是什么新鲜事了,很多电脑爱好者也都非常喜欢组装电脑,组装电脑不仅价格便宜,最重要的是能在组装电脑过程中能够学到不少电脑硬件知识,武汉电脑网为大家提供电脑配置单已经有了一段时间了,如果您对 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLaPy8z.html" rel="bookmark" class="title">电脑一开语音聊天就蓝屏的解决办法</a>
					<div>
						  1.显卡.CPU.内存是不是超频了?降低频率; 2.机器整体散热不够,加强散热;硬件更新; 3.内存重新插拔,或者更换插槽.内存加大; 4.硬盘保护,用EVEREST软件检查硬盘是否有坏道; 5. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pmG59jb.html" rel="bookmark" class="title">JBOSS 配置mysql 数据源</a>
					<div>
						1 , 首先查找JBOSS目录,找到 mysql-ds.xml文件,在其基础上进行修改 1.&lt;datasources&gt; 2. &lt;local-tx-datasource&gt; 3.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8Z4Bob.html" rel="bookmark" class="title">Docker学习之常用的基础命令总结&lowbar;docker</a>
					<div>
						前言 Docker是一个用了一种新颖方式实现的超轻量虚拟机,在实现的原理和应用上还是和VM有巨大差别,专业的叫法是应用容器(Application Container).下面这篇文章将简单介绍一下Do ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvrRX9M.html" rel="bookmark" class="title">jQuery 实现自动填充邮箱功能（带下拉提示）&lowbar;jquery</a>
					<div>
						在做这个功能时候,我参考的是网易注册(http://reg.163.com/reg/reg.jsp?product=urs)中的邮箱栏目所实现的功能与效果.这个功能的目的是使用户在填写邮箱栏目的过程中 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zwxWJnb.html" rel="bookmark" class="title">UCloud云直播ULive 助力&OpenCurlyDoubleQuote;直播&plus;&rdquo;生态创业</a>
					<div>
						十多年前人们在视频聊天室打发时间时,一定不会想到如今围绕直播所诞生的广阔蓝海. 2015年起,这一互联网最古老的行业再次焕发活力.iResearch调查显示,2015Q3中国在线视频市场规模达 115 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pLm7VWz.html" rel="bookmark" class="title">argo数据获取及读取方法</a>
					<div>
						问题描述 argo数据获取及读取方法 请问argo数据如何下载以及如何读取?我要做海水的盐度反演,需要用Argo数据作为辅助数据. 解决方案 参考Argo data and how to get it ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M6NGjLM.html" rel="bookmark" class="title">win32程序中简单应用mfc</a>
					<div>
						今日写程序在win32中用CRect发现报错,突然想起来.要引入mfc库.想重新建立一个工程添加对mfc的支持.发现选项不能选.查资料后发现. 在win32程序中简单应用mfc库,只需要简单的引入&l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWavWp.html" rel="bookmark" class="title">机房收费系统个人重构关于SQLHelper</a>
					<div>
						              最近在敲机房,对于SQLHelper也是心里有些怵,因为原来没用过,但是看了一些博客和资料后发现,如果不用这个类,会大大增加代码量,而且,其实它并不新,它是一个有多个关于数 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5Nrmnz.html" rel="bookmark" class="title">cygwin中用rpm -ivh 安装一直提示command not found为什么</a>
					<div>
						问题描述 cygwin中用rpm -ivh 安装一直提示command not found为什么 $ rpm -ivh avarice-2.4-1.cygwin.i386.rpm bash: rpm: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2PagQp.html" rel="bookmark" class="title">Groovy学起来，这要和GRAILS&comma;RUNDECK打成一片</a>
					<div>
						还好,以前看过RUBY和JAVA,GROOVY感觉和它们有点相似.. 并且,我觉得这个GROOVY比SCALA要简单些(函数式编程+OBJ) 作类比,毕竟是最快的学习方法. XXX,还有必修课和证券从 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z4NDe8M.html" rel="bookmark" class="title">富士康将投巨资在美新建两座液晶面板厂 美国各州疯抢</a>
					<div>
						富士康集团收购夏普之后,开始大规模振兴液晶面板和电视机业务.之前媒体纷纷报告,富士康和夏普准备在美国建设一个面板工厂,这也是响应美国总统特朗普&quot;美国制造&quot;战略的举动. 不过据日经新 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5NDlmz.html" rel="bookmark" class="title">javascript-开发一个网站，可以在客户端用JavaScript，服务器端用php吗？</a>
					<div>
						问题描述 开发一个网站,可以在客户端用JavaScript,服务器端用php吗? 开发一个网站,可以在客户端用JavaScript,服务器端用php吗? 解决方案 用什么语言可以不可以看你会什么语言. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/boK7qvb.html" rel="bookmark" class="title">ios-iOS中实现界面跳转的方式出了push和模态，还有其他方法吗？</a>
					<div>
						问题描述 iOS中实现界面跳转的方式出了push和模态,还有其他方法吗? iOS中实现界面跳转的方式出了push和模态,还有其他方法吗? 解决方案 http://www.cnblogs.com/tai ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqRJQ2p.html" rel="bookmark" class="title">C语言库函数大全及应用实例三</a>
					<div>
						原文:C语言库函数大全及应用实例三 [编程资料]C语言库函数大全及应用实例三 函数名: ecvt 功 能: 把一个浮点数转换为字符串 用 法: char ecvt(double value, int  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MvmVYVb.html" rel="bookmark" class="title">如何在React Native中写一个自定义模块</a>
					<div>
						前言 在 React Native 项目中可以看到 node_modules 文件夹,这是存放 node 模块的地方,Node.js 的包管理器 npm 是全球最大的开源库生态系统.提到npm,一般指 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pnR9wjp.html" rel="bookmark" class="title">Tomcat 系统架构与设计模式--工作原理</a>
					<div>
						本文以 Tomcat 5 为基础,也兼顾最新的 Tomcat 6 和 Tomcat 4.Tomcat 的基本设计思路和架构是具有一定连续性的. Tomcat 总体结构 Tomcat 的结构很复杂,但是 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bjwNnmM.html" rel="bookmark" class="title">Phone 蓝牙通信编程&lpar;初级&rpar;</a>
					<div>
						原文地址:http://tech.it168.com/a2010/0114/837/000000837727.shtml iPhone OS 3.0的最佳功能是GameKit框架,这个框架包括了允许基 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYNBj9p.html" rel="bookmark" class="title">详解iOS多线程GCD问题&lowbar;IOS</a>
					<div>
						在iOS所有实现多线程的方案中,GCD应该是最有魅力的,因为GCD本身是苹果公司为多核的并行运算提出的解决方案.GCD在工作时会自动利用更多的处理器核心,以充分利用更强大的机器.GCD是Grand C ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/ze0x2wp.html" rel="bookmark" class="title">JavaScript使用cookie实现记住账号密码功能&lowbar;javascript技巧</a>
					<div>
						很多登录功能上都有个&quot;记住密码&quot;的功能,其实无非就是对cookie的读取. 下面展示这个功能的代码,原作者已无法考究.... 测试方法:直接输入账号密码,提交后,刷新页面,再输入同 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p8NR39b.html" rel="bookmark" class="title">PHP生成网站桌面快捷方式代码分享&lowbar;php技巧</a>
					<div>
						PHP生成桌面快捷方式就是这么的简单,大家生成的时候改下你要生成的网站即可. dianji.html代码: 复制代码 代码如下: &lt;a href=&quot;a.php?url=www.jb51 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
